% M-file 9.26
% UX_voiced.m

% feature_voice is a measure of the maximum of the second peak
% on a zero phase spectrum issued form FFT

clear;clf

%----- USER DATA -----
[DAFx_in, SR]  = wavread('toms_diner.wav');
hop            = 256;  % hop size between two FFTs
WindowLength   = 1024; % length of the windows
w              = hanningz(WindowLength);


%----- some initialisations -----
WindowLength2  = WindowLength/2;
tx             = (1:WindowLength2+1)';
normW          = norm(w,2);
coef           = (WindowLength/(2*pi));
pft            = 1;
lf             = floor((length(DAFx_in) - WindowLength)/hop);
feature_voiced = zeros(lf,1);

tic
%===========================================
pin  = 0;
pend = length(DAFx_in) - WindowLength;

while pin<pend
   grain    = DAFx_in(pin+1:pin+WindowLength).* w;
   f        = fft(grain)/WindowLength2;
   f2       = real(ifft(abs(f)));
   f2       = f2/f2(1);
   [v,i1]   = min(f2(1:WindowLength2)>0.);
   f2(1:i1) = zeros(i1,1);
   [v,imax] = max(f2(1:WindowLength2));
   feature_voiced(pft) = v;
   pft      = pft + 1;
   pin      = pin + hop;
end
% ===========================================
toc

n_signal = 1:pend; 
t_signal = (n_signal-1)/SR; % time in sec

t_voiced = (0:pft-2)*hop/SR;

subplot(2,1,1); 
plot(t_signal, DAFx_in(n_signal)); 
title('Signal')
xlabel('t/s \rightarrow')
axis([0 max(t_signal) [-1.2 1.2]*max(abs(DAFx_in))])

subplot(2,1,2)
plot(t_voiced, feature_voiced)
title('voiced/unvoiced feature')
xlabel('t/s \rightarrow')
axis([0 max(t_signal) 0 1.2*max(feature_voiced)])
