clear all; close all;
[y, fs, nbits] = wavread('violin_A4.wav');


%sound(y,fs);                                % ascolto in ambiente windows/linux

fprintf(' premere un tasto per ascoltare violin_A4.wav\n');
pause;                                      % premere un tasto per proseguire

sound(y, fs);                       % ascolto dei primi 2 secondi
pause(4);                                   % aspetta 2 secondi (il suono va in background)

fprintf(' premere un tasto per proseguire...\n\n');
pause

fprintf(' calcolo della Short-Time Average Energy\n\n');
fprintf(' e della Short-Time Average Magnitude\n\n');

y = resample(y, 1, 3);
Nframe=100; % numero di campioni per frame
Ns=max(size(y)); % numero di campioni del segnale
for n=1:Ns; % calcola la Short-Time Average Energy
E(n,1)=sum(y(max(1,n-Nframe+1):n).*y(max(1,n-Nframe+1):n))/Nframe;
end;
for n=1:Ns; % calcola la Short-Time Average Magnitude
M(n,1)=sum(abs(y(max(1,n-Nframe+1):n)))/Nframe;
end;
% disegna E(t) e M(t)
E=E/max(E); % normalizza E(t)
tempi = (1/fs)*[1:max(size(E))]; subplot(2,1,1);
figure(1);
plot(tempi,E); xlabel('time(s)'); ylabel('E(t)');
M=M/max(M); % normalizza M(t)
tempi = (1/fs)*[1:max(size(M))]; subplot(2,1,2);
plot(tempi,M); xlabel('time(s)'); ylabel('M(t)');
fprintf(' premere un tasto per proseguire...\n\n');
pause
close(figure(1));
fprintf('Calcolo Zero-Crossing rate sul file sono_mine.wav:\n');

% Zero-Crossing rate

[y, fs, nbits] = wavread('sono_mine.wav');
fprintf(' premere un tasto per ascoltare sono_mine.wav\n');
pause;                            
sound(y, fs);                      
pause(2);                                    
fprintf(' premere un tasto per calcolare ZCR...\n\n');
pause;
Nframe = 100; % numero di campioni per frame
Ns = max(size(y));
for n = 1+Nframe:Ns; % calcola la Short-Time Average ZCR
Z(n,1) = sum(abs(sign(y(n-Nframe+1:n))-sign(y(n-Nframe:n-1)))/2)/Nframe;
end;
Z=Z*fs/1000; % Zero-Crossing per ms
% disegna Z(t):
t = (1/fs)*[1:max(size(Z))];
figure(1);
plot(t,Z); xlabel('time(s)'); ylabel('ZCR/ms(t)'); title('Zero-Crossing rate')

% Resampling

[y, fs, nbits] = wavread('singer_A4.wav');
fprintf(' premere un tasto per ascoltare singer_A4.wav\n');
pause;                            
sound(y, fs);                      
pause(4);                                    
fprintf('ascoltiamolo riprodotto a diversa frequenza di campionamento \n\n');
pause;
y2=resample(y,1,4);
fprintf('la nuova fs  maggiore o minore? \n\n');
sound(y2, fs);   
pause;
y3=resample(y,3,1);
fprintf('era riprodotto a fs/2. ora invece a 3*fs \n\n');
sound(y3, fs);   
pause;

% Autocorrelazione
fprintf('...calcolo autocorrelazione (figura 1)\n\n');
Ns = max(size(y2)); %no. of samples
window = ones(Ns,1); %rectangular window
s_w = y2.*window;
for k = 1:Ns-1; %compute ST autocorrelation
R0(k) = sum(s_w(1:Ns-k).* s_w(k+1:Ns));
end;
%plots
R0=R0/max(abs(R0)); %normalize R0
figure(1);
plot(1:max(size(R0)),R0); xlabel('k'); ylabel('R_0(k)');title('Autocorrelazione')
pause;

% Pitch con autocorrelazione
fprintf(' premere un tasto per calcolare il pitch...\n');
pause;                            
inizio=floor(fs*0.001); % salta il primo massimo
[massimo,kM] = max(R0(inizio:max(size(R0))));
kM=kM + inizio -1;
F0=fs/kM;
fprintf('Pitch individuato con autocorrelazione= %d Hz \n', F0);
pause;                                      
fprintf(' premere un tasto per proseguire...\n\n');
close(figure(1));
% Pitch con FFT (fase)

x=y;
Nfft=1024;
win=ones(Nfft,1); % provare con hanning
Fs=fs;
R=1;
fmin=80;
fmax=5000;
thres=20;

[FFTidx, Fp_est, Fp_corr] = find_pitch_fft(x, win, Nfft, Fs, R, fmin, fmax, thres);
fprintf('Pitch individuato con FFT= %d Hz \n', Fp_est);
pause;        
fprintf(' premere un tasto per proseguire...\n\n');

t = [0:1/fs:(length(y)-1)/fs];             % time vector
yr = 0.4*sin(2*pi*Fp_est*t);      % sinusoide, ampiezza = 1

fprintf('confronto con sinusoide a %d Hz \n', Fp_est);
soundsc(yr,fs);
pause;
fprintf('... e assieme... \n', Fp_est);
xx=[y,yr'];
soundsc(xx,fs);
pause;        


% pitch tracking con FFT
fprintf('pitch tracking mediante FFT\n\n');
fprintf('Brano: Suzanne Vega (Toms Diner)\n\n');
[y, fs, nbits] = wavread('Toms_diner.wav');
soundsc(y,fs);

fprintf('premere un tasto per proseguire...\n\n');
fprintf('pitch tracking...\n\n');
pitch_tracker_fft_main();
pause; 
[td, fs2, nbits2] = wavread('Toms_diner_pitch_fft.wav');
fprintf('premi un tasto per ascoltarli assieme...\n\n');
pause; 
%aa=y(1:(length(td))); bb=td(1:(length(td)));
[y, fs, nbits] = wavread('Toms_diner.wav');
aa=y(1:4*fs); bb=td(1:4*fs);
cc=[aa,bb];
soundsc(cc,fs);
