clear all; close all;
%[y, fs, nbits] = wavread('chopin_pollini.wav');
%DAFx_in=y; SR=fs;
[y, fs, nbits] = wavread('flute2.wav');
fprintf(' premere un tasto per ascoltare flute2.wav\n');
pause;                          % premere un tasto per proseguire
sound(y, fs);
pause(length(y)/fs);
fprintf(' premere un tasto per calcolare centroide\n');
pause; 
UX_centroid();
fprintf(' premere un tasto per riascoltare Toms Diner\n');
pause;
[y, fs, nbits] = wavread('Toms_diner.wav');
soundsc(y,fs);
pause(length(y)/fs); 
fprintf(' premere un tasto per visualizzare lo spettrogramma\n');
pause;
close(figure(1));
figure(1);
plot(y),axis tight,grid on;
specgram(y, 512, fs);
colorbar;
    
[y, fs, nbits] = wavread('whitenoise.wav');
fprintf('premere un tasto per ascoltare un esempio di rumore bianco\n');
fprintf('(stessa energia su tutte le frequenze)\n');
pause;
close(figure(1));
sound(y, fs);
fprintf('segnale e spettro del rumore bianco\n');
fs = 44100;
n = randn(fs, 1);
n = n / max(abs(n));
subplot(211)
plot(n), axis tight
subplot(212)
specgram(n);

[y, fs, nbits] = wavread('piano-G4.wav');
fprintf('premere un tasto per ascoltare piano-G4.wav\n');
pause;
close(figure(1));
sound(y, fs);
fprintf('il suono del piano  armononico (o quasi)\n');
fprintf('cosa significa?\n');
figure(1);
plot(y),axis tight,grid on; title('signal (time domain) of piano-G4.wav')
y2 = resample(y, 1, 3);
figure(2);
specgram(y2, 512, fs / 3); title('spectrogram of piano-G4.wav')
colorbar;

[y, fs, nbits] = wavread('trumpet-G4.wav');
fprintf('premere un tasto per ascoltare trumpet-G4.wav\n');
pause;
close(figure(1));close(figure(2));
sound(y, fs);
fprintf('il suono della tromba?\n');
pause(length(y)/fs);
figure(1);
plot(y),axis tight,grid on;
y2 = resample(y, 1, 3);
figure(2);
specgram(y2, 512, fs / 3);
colorbar;

fprintf('confrontiamo diversi strumenti\n');
[y1, fs, nbits] = wavread('trumpet-G4.wav');
fprintf('premere un tasto per ascoltare la tromba\n');
pause;
sound(y1, fs);
[y2, fs, nbits] = wavread('piano-G4.wav');
fprintf('premere un tasto per ascoltare il piano\n');
pause(length(y1)/fs);
sound(y2, fs);
[y3, fs, nbits] = wavread('violin-G4.wav');
fprintf('premere un tasto per ascoltare il violino\n');
pause(length(y2)/fs);
sound(y3, fs);
[y4, fs, nbits] = wavread('flute-G4.wav');
fprintf('premere un tasto per ascoltare il flauto\n');
pause(length(y4)/fs);
sound(y4, fs);

figure(1);
subplot(2,2,1); plot(y1),axis tight,grid on;
specgram(y1, 512, fs); 
title('tromba');
subplot(2,2,2); plot(y2),axis tight,grid on; 
specgram(y2, 512, fs);  
title('piano');
subplot(2,2,3); plot(y3),axis tight,grid on;
specgram(y3, 512, fs);  
title('violino');
subplot(2,2,4); plot(y4),axis tight,grid on;
specgram(y4, 512, fs);  
title('flauto');
fprintf('premere un tasto per continuare\n');
pause;
[y, fs, nbits] = wavread('snareHit.wav');
fprintf('premere un tasto per ascoltare un suono di rullante\n');
pause;
close(figure(1));
sound(y, fs);
fprintf('premere un tasto per calcolare modulo della FFT e ampiezza in dB\n');
pause;
subplot(211), plot(abs(fft(y))), title('abs(fft(y))')    
subplot(212), plot(y), title('y')
u = y(0.2 * fs:0.2 * fs + 511) .* hanning(512);
U = fft(u);
f = (0:256) / 256 * fs / 2;
figure(2);
plot(f, 20 * log10(abs(U(1:257))))
axis tight,grid on
xlabel('frequency [Hz]')
ylabel('amplitude [dB]')
fprintf('premere un tasto per calcolare spettrogramma\n');
pause;
figure(3);
specgram(y, 512, fs);
colorbar;


% finestratura
[s, fs] = wavread('piano.wav');
fprintf('premere un tasto per ascoltare piano.wav\n');
pause;
sound(s, fs);
[s, fs] = wavread('piano.wav', [5000 6000]);
fprintf('ne prendo i campioni da 5000 a 6000\n');
fprintf('premere un tasto per ascoltare (molto breve, quanto in secondi?)\n');
pause;
sound(s, fs);
fprintf('esempio di finestratura\n');
fprintf('premere un tasto per visualizzare piano.wav (primi 512 campioni), la finestra e il segnale finestrato. \n');
pause;
close(figure(2));
close(figure(3));

figure(1);
subplot(131)
plot(s(1:512))
title('s(1:512)'), axis tight, grid on
subplot(132)
plot(hanning(512),'r')
title('hanning(512)'), axis tight, grid on
subplot(133)
plot(s(1:512) .* hanning(512))            
title('s(1:512) .* hanning(512)'), axis tight, grid on

fprintf('ampiezza del segnale originale e finestrato (premi un tasto)\n');
pause;
figure(2);
S1 = fft(s(1:512));
S2 = fft(s(1:512) .* hanning(512));
f = (0:256) / 256 * fs / 2;
plot(f, 20 * log10(abs(S1(1:257))))
hold on
plot(f, 20 * log10(abs(S2(1:257))), 'r')
axis tight,grid on
xlabel('frequency [Hz]')
ylabel('amplitude [dB]')
